#!/sbin/ash

if [ ! -e /sdcard/samdroid ];
then
	mkdir /sdcard/samdroid
fi;
DEVICE="/dev/stl5"
DIR="/data"
umount $DEVICE
	true
	if [ $? = 0 ];
	then
		LOGM1=`mount -t rfs -o rw,nosuid,nodev,codepage=utf8,xattr,check=no ${DEVICE} ${DIR} 2>&1`
		RES=$?
		FS="RFS"
		if [ ! $RES = 0 ];
		then
			mount -t ext4 -o rw,nosuid,nodev,noatime,nodiratime,barrier=1,data=ordered $DEVICE $DIR
			RES=$?
			FS="EXT4"
		fi;
		if [ ! $RES = 0 ];
		then
			mount -t ext2 -o rw,noatime,nodiratime,nodev,nosuid $DEVICE $DIR
			RES=$
			SYSLOG="EXT2"
		fi;
		if [ $RES = 0 ];
		then
			FILE="/sdcard/samdroid/Backup_data_${FS}toEXT2.tar"
			if [ -e $FILE ];
			then
				rm -f $FILE
			fi;
			if [ -e /data/dalvik-cache ];
			then
				rm -rf /data/dalvik-cache
				#echo "dalvik-cache wiped from /data, (sd-ext fs:${FS)" > /sdcard/dalvik_data.log
			fi;
			#TAR=`tar cf ${FILE} ${DIR} --exclude ?RFS_LOG.LO? 2>&1`
			tar cf $FILE $DIR --exclude ?RFS_LOG.LO?
			if [ $? = 0 ];
			then
				umount $DIR
				if [ $? = 0 ];
				then
					mount -o remount,rw /system
					RES=$?
					SYSLOG="REMOUNT"
					if [ $RES = 0 ];
					then
						umount /dev/stl6
						LOGM2=`mount -t rfs -o rw,nosuid,nodev,codepage=utf8,xattr,check=no /dev/stl6 /system 2>&1`
						RES=$?
						SYSLOG="RFS"
						if [ ! $RES = 0 ];
						then
							LOGM3=`mount -t ext4 -o rw,nosuid,nodev,noatime,nodiratime,barrier=1,data=ordered /dev/stl6 /system 2>&1`
							RES=$?
							SYSLOG="EXT4"
						fi;
						if [ ! $RES = 0 ];
						then
							LOGM4=`mount -t ext2 -o rw,noatime,nodiratime,nodev,nosuid /dev/stl6 /system 2>&1`
							RES=$
							SYSLOG="EXT2"
						fi;
					fi;
					if [ $RES = 0 ];
					then
						touch /etc/mtab
						if [ $? = 0 ];
						then
							mkfs.ext2 -m 0 -b 4096 $DEVICE
							e2fsck -y $DEVICE
							mount -t ext2 -o rw,noatime,nodiratime,nodev,nosuid $DEVICE $DIR
							cd /
							tar xf $FILE
							umount $DIR
							echo "/data converted successfuly!" > /sdcard/ext2_data.log
						else
							echo "/data conversion error: unable to create /etc/mtab" > /sdcard/ext2_data.log
						fi;
					else
						echo "/data conversion error: unable to mount /system as rw (reboot to recovery, and try again)" > /sdcard/ext2_data.log
					fi;
				else
					echo "/data backuping error: unable to unmount /data" > /sdcard/ext2_data.log
				fi;
			else
				if [ -e $FILE ];
				then
					rm -f $FILE
				fi;
				echo "/data backuping error: probably, not enough space on SD card" > /sdcard/ext2_data.log
			fi;

		else
			echo "/data conversion error: unable to mount /data" > /sdcard/ext2_data.log
		fi;
	fi;

#echo "fs:${FS} / s:${SYSLOG} / m1:${LOGM1} / m2:${LOGM2} / m3:${LOGM3} / m4:${LOGM4} / ${TAR}" > /sdcard/data_debug.log